Subject: Re: [Bugme-new] [Bug 14794] New: IP address assigned by DHCP is dropped after ~40 seconds

From: Németh Márton <[email-masked]>
Date: Fri, 18 Dec 2009 08:56:39 +0100

Hi,
Jarek Poplawski wrote:
> Andrew Morton wrote, On 12/17/2009 10:24 PM:
> 
>> On Thu, 17 Dec 2009 21:53:20 +0100
>> Németh Márton <[email-masked]> wrote:
>>
>>> Hi,
>>>
>>> I bisected the problem, see http://bugzilla.kernel.org/show_bug.cgi?id=14794
>>> for details. Any idea what is the relation between this problem and the found
>>> patch?
>>>
>> : 61cbe54d9479ad98283b2dda686deae4c34b2d59 is the first bad commit
>> : commit 61cbe54d9479ad98283b2dda686deae4c34b2d59
>> : Author: Mike Galbraith <[email-masked]>
>> : Date:   Wed Sep 9 15:41:37 2009 +0200
>> :
>> :    sched: Keep kthreads at default priority
>>
>> Strange.  Might be a timing thing bu a) I doubt if any kernel threads
>> are involved in maintaining a DHCP lease and b) even if they were, such
>> a race wouldn't be this repeatable.
>>
> 
> "Removes kthread/workqueue priority boost[...]" - if there could be
> workqueues involved - maybe something with link-watch?

Unfortunately reverting the commit 61cbe54d9479ad98283b2dda686deae4c34b2d59 on
top of 2.6.32 does not solve the problem.

I use KDE, and the KNetworkManager icon is visible on the task bar. When
I unplug the network cable the "disconnected" icon appears. After I plug the
network cable again, a rotating wheel appears. Here comes the difference: *when*
the rotating wheel changes to "connected" state. One case, when the IP address
is kept the "connected" icon appears right after the IP address assigned by
DHCP appears in the ifconfig output. In the wrong case this rotating wheel is
still there for about 60 seconds while the the assigned IP address is dropped
and an IP address like 169.254.123.251 is assigned.

There is a workaround, too. If the IP address 169.254.123.251 was assigned and
I execute "dhclient eth0" as root, an IP address will be assigned by DHCP and
this address is not dropped anymore until I again unplug and replug the network
cable.

My driver for the network card is 8139too. My network card is:

00:08.0 Ethernet controller: Realtek Semiconductor Co., Ltd. RTL-8139/8139C/8139C+ (rev 10)
        Subsystem: CLEVO/KAPOK Computer Device 4702
        Flags: bus master, medium devsel, latency 64, IRQ 19
        I/O ports at 1000 [size=256]
        Memory at d0004000 (32-bit, non-prefetchable) [size=256]
        Capabilities: [50] Power Management version 2
        Kernel driver in use: 8139too
        Kernel modules: 8139too

Regars,

	Márton Németh